package be.iminds.ilabt.jfed.rspec.model;

import be.iminds.ilabt.jfed.rspec.parser.ExtraXml;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

/**
 * OpenflowSliver
 */
public class OpenflowSliver {
    public static class Group {
        @Nullable private final String name;
        @Nonnull private final List<OpenflowDataPath> dataPaths;

        public Group(@Nullable String name, @Nonnull List<OpenflowDataPath> dataPaths) {
            this.name = name;
            this.dataPaths = dataPaths;
        }

        @Nonnull
        public List<OpenflowDataPath> getDataPaths() {
            return dataPaths;
        }

        @Nullable
        public String getName() {
            return name;
        }
    }

    @Nonnull private final ExtraXml asExtraXml;

    @Nullable private final String email;
    @Nullable private final String description;
    @Nullable private final String ref;
    @Nonnull private final List<Group> groups;

    public OpenflowSliver(@Nonnull ExtraXml asExtraXml,
                          @Nullable String email,
                          @Nullable String description,
                          @Nullable String ref,
                          @Nonnull List<Group> groups) {
        this.asExtraXml = asExtraXml;
        this.email = email;
        this.description = description;
        this.ref = ref;
        this.groups = groups;
    }

    @Nonnull
    public ExtraXml getAsExtraXml() {
        return asExtraXml;
    }

    @Nullable
    public String getEmail() {
        return email;
    }

    @Nullable
    public String getDescription() {
        return description;
    }

    @Nullable
    public String getRef() {
        return ref;
    }

    @Nonnull
    public List<Group> getGroups() {
        return groups;
    }
}
